'---------------------------------------------------------------------------------
' June/2001
' Start of a Simple Edit Control Class:
'
' Demonstration of Caret movement and Text Highlighting.
' Started by Jules Marchildon.
'
' Added 7/6/2011, old forum discussion links...
' http://www.powerbasic.com/support/forums/Forum6/HTML/001779.html
' http://www.powerbasic.com/support/forums/Forum6/HTML/001137.html
'---------------------------------------------------------------------------------
#COMPILE EXE
#INCLUDE "WIN32API.INC"

GLOBAL  sBuffer()          AS STRING
GLOBAL  ghCaretw           AS LONG   '-debug window->caret position info
GLOBAL  ghSelectw          AS LONG   '-debug window->selection position info
GLOBAL  ghEdit             AS LONG
GLOBAL  ghMain             AS LONG
GLOBAL  ghOpen             AS LONG   '-debug button->Open File dialog box
GLOBAL  ghSave             AS LONG   '-debug button->Save File dialog box
GLOBAL  ghParent           AS LONG
GLOBAL  ghInst             AS LONG
GLOBAL  gid                AS LONG
GLOBAL  gcyChar            AS LONG
GLOBAL  gcxChar            AS LONG
GLOBAL  gwMaxHeight        AS LONG
GLOBAL  gwMaxWidth         AS LONG
GLOBAL  gwFirstVisibleLine AS LONG
GLOBAL  gwFirstVisibleCol  AS LONG
GLOBAL  gwLastLine         AS LONG
GLOBAL  gwLastVisibleCol   AS LONG
GLOBAL  gtLineCount        AS LONG
GLOBAL  gtColCount         AS LONG
GLOBAL  ghBit              AS LONG
GLOBAL  gmemDC             AS LONG
GLOBAL  ghFont             AS LONG
GLOBAL  gpBuf              AS STRING PTR
GLOBAL  gutter             AS LONG
GLOBAL  xCaret             AS LONG
GLOBAL  yCaret             AS LONG
GLOBAL  SelStartX          AS LONG
GLOBAL  SelStartY          AS LONG
GLOBAL  SelEndX            AS LONG
GLOBAL  SelEndY            AS LONG
GLOBAL  gcurLine           AS LONG
GLOBAL  gcurCol            AS LONG
GLOBAL  gTabSize           AS LONG
'---
%SP  = 32   'space character
%BS  = 8    'backspace character
%TAB = 9    'tab character
%LF  = 10   'line feed character
%CR  = 13   'carriage return character
%ESC = 27   'escape character

'-------------------------------------------------------------------------------
'  See Caret position window for info...
'-------------------------------------------------------------------------------
SUB ShowCaretPosition(BYVAL hWnd AS LONG,BYVAL xCaret AS LONG, BYVAL yCaret AS LONG)
  LOCAL zInfo AS ASCIIZ*255
  '---this is the total line count
  'zInfo = "Lines = " + str$(gtLineCount)
  'SendMessage( ghSelectw, %WM_SETTEXT, 0 , VARPTR(zInfo) )
  '---this is the selection boundary, start - end (in terms of charcter position)
  zInfo = "selStart Row,Col: "+STR$(SelStartY)+","+STR$(SelStartX)+"   "+"selEnd Row,Col: "+STR$(SelEndY)+","+STR$(SelEndX)
  SendMessage( ghSelectw, %WM_SETTEXT, 0, VARPTR(zInfo) )
  '---this is the position of the cursor (in terms of character Row/Col)
  'zInfo = "Line: " + str$(yCaret+gwFirstVisibleLine)  + " , " + "Col:" + str$(xCaret+gwFirstVisibleCol)
  zInfo = "Line: " + STR$(gcurLine)  + " , " + "Col:" + STR$(gcurCol)
  SendMessage( ghCaretw, %WM_SETTEXT, 0, VARPTR(zInfo) )
  '---this is the first visible row and col
  'zInfo = "TopRow: " + str$(gwFirstVisibleLine) + " , " + "LeftCol: " + str$(gwFirstVisibleCol)
  'SendMessage( ghCaretw, %WM_SETTEXT, 0, VARPTR(zInfo) )
END SUB

'---------------------------------------------------------------------------------
'
'---------------------------------------------------------------------------------
SUB PositionCaret()
     y& = gcurLine - gwFirstVisibleLine
     x& = gcurCol  - gwFirstVisibleCol
     SetCaretPos( x&*gcxChar, y&*gcyChar )
END SUB

'---------------------------------------------------------------------------------
' Set VERTICAL Scroll bar info
'---------------------------------------------------------------------------------
SUB SetVScrollData(BYVAL hwnd AS LONG,BYVAL cPageHeight AS LONG,BYVAL cLineCount AS LONG,BYVAL cwFirstLine AS LONG)
  LOCAL si AS SCROLLINFO
  si.cbSize = SIZEOF(si)
  si.fMask  = %SIF_ALL ' OR %SIF_DISABLENOSCROLL
  si.nMin   = 0
  si.nMax   = MAX&(0, cLineCount)
  si.nPage  = cPageHeight
  si.nPos   = cwFirstLine
  SetScrollInfo( hWnd, %SB_VERT, si, %TRUE )
END SUB

'---------------------------------------------------------------------------------
' Set HORZ Scroll bar info
'---------------------------------------------------------------------------------
SUB SetHScrollData(BYVAL hwnd AS LONG, BYVAL cPageWidth AS LONG, BYVAL cColCount AS LONG, BYVAL cwFirstCol AS LONG)
  LOCAL si AS SCROLLINFO
  si.cbSize = SIZEOF(si)
  si.fMask  = %SIF_ALL ' OR %SIF_DISABLENOSCROLL
  si.nMin   = 0
  si.nMax   = MAX&(0, cColCount)
  si.nPage  = cPageWidth
  si.nPos   = cwFirstCol
  SetScrollInfo( hWnd, %SB_HORZ, si, %TRUE )
END SUB

'--------------------------------------------------------------------------------
' Tip from Lance Edmonds FEB/09/2001.
' A PowerBasic Replacement for the API CopyMemory() function
'--------------------------------------------------------------------------------
SUB CopyMemoryPB(BYVAL lpDest AS DWORD,BYVAL lpSource AS DWORD,BYVAL cbLength AS LONG)
    POKE$ lpDest, PEEK$(lpSource, cbLength)
END SUB

'--------------------------------------------------------------------------------
'
'--------------------------------------------------------------------------------
FUNCTION AddLineToEndofArray() AS LONG
   LOCAL pt AS POINTAPI
   GetCaretPos( pt )
   i& = UBOUND(sBuffer)+1
   REDIM PRESERVE sBuffer(i&)
   stemp$ = "This is a new line at the end of the file, line no." + STR$(i&)
   sBuffer(i&) = stemp$
   '-update our line counter
   gtLineCount = UBOUND(sBuffer)
   gpBuf = VARPTR(sBuffer(0))
   '-next we need to update our Edit windows variables and refresh the output
   InvalidateRect( ghEdit, BYVAL %NULL, 0 )
   SetFocus( ghEdit )
   SetCaretPos( pt.x, pt.y )
   FUNCTION =1
END FUNCTION

'--------------------------------------------------------------------------------
'
'--------------------------------------------------------------------------------
FUNCTION UpdateLineInArray() AS LONG
   LOCAL pt AS POINTAPI
   GetCaretPos( pt )
   stemp$ =sBuffer(10)   '-keep for undo
   sUpdate$ = "this string has been updated, Line no. " + STR$(10)
   sBuffer(10) = sUpdate$
   '-next we need to update our Edit windows variables and refresh the output
   InvalidateRect( ghEdit, BYVAL %NULL, 0 )
   SetFocus( ghEdit )
   SetCaretPos( pt.x, pt.y )
   FUNCTION =1
END FUNCTION

'--------------------------------------------------------------------------------
'
'--------------------------------------------------------------------------------
FUNCTION InsertLineToArray() AS LONG
   LOCAL pt AS POINTAPI
   GetCaretPos( pt )
   i& = UBOUND(sBuffer)+1
   REDIM PRESERVE sBuffer(i&)
   stemp$ = "A small line was inserted here..."
   ARRAY INSERT sBuffer(10), stemp$
   '-update our line counter
   gtLineCount = UBOUND(sBuffer)
   gpBuf = VARPTR(sBuffer(0))
   '-next we need to update our Edit windows variables and refresh the output
   InvalidateRect( ghEdit, BYVAL %NULL, 0 )
   SetFocus( ghEdit )
   SetCaretPos( pt.x, pt.y )
  FUNCTION =1
END FUNCTION

'--------------------------------------------------------------------------------
'
'--------------------------------------------------------------------------------
FUNCTION DeleteLineFromArray() AS LONG
   LOCAL pt AS POINTAPI
   GetCaretPos( pt )
   ARRAY DELETE sBuffer(10)
   IF UBOUND(sBuffer) THEN
      REDIM PRESERVE sBuffer(UBOUND(sBuffer)-1)
   ELSE
      '-ERASE sBuffer
   END IF
   '-update our line counter
   gtLineCount = UBOUND(sBuffer)
   gpBuf = VARPTR(sBuffer(0))
   '-next we need to update our Edit windows variables and refresh the output
   InvalidateRect( ghEdit, BYVAL %NULL, 0 )
   SetFocus( ghEdit )
   SetCaretPos( pt.x,pt.y )
   FUNCTION = 1
END FUNCTION

'--------------------------------------------------------------------------------
' Simple Edit procedure:
'--------------------------------------------------------------------------------
FUNCTION SimpleEditProc(BYVAL hWnd AS LONG,BYVAL uMsg AS LONG,BYVAL wParam AS LONG,BYVAL lParam AS LONG)AS LONG

  LOCAL  tm             AS TEXTMETRIC
  LOCAL  rc             AS RECT
  LOCAL  wRect          AS RECT
  LOCAL  pt             AS POINTAPI
  LOCAL  y              AS LONG
  LOCAL  i              AS LONG
  LOCAL  ps             AS PAINTSTRUCT
  LOCAL  hDC            AS LONG
  LOCAL  hBrush         AS LONG
  LOCAL  bBrush         AS LONG
  LOCAL  hBrushSel      AS LONG
  LOCAL  hOldBrushSel   AS LONG
  LOCAL  hPen           AS LONG
  LOCAL  hPenOld        AS LONG
  LOCAL  iVscrollInc    AS LONG
  LOCAL  iHscrollInc    AS LONG
  LOCAL  si             AS SCROLLINFO
  LOCAL  tSel           AS LONG
  STATIC selOnOff       AS LONG
  LOCAL  xPos           AS INTEGER
  LOCAL  yPos           AS INTEGER
  STATIC bLButtonIsDown AS LONG
  STATIC bSelected      AS LONG
 'static xCaret         as long
 'static yCaret         as long
  STATIC bTimerOnOff    AS LONG

  SELECT CASE uMsg
     CASE %WM_CREATE
        ghParent    = GetWindowLong(hWnd, %GWL_HWNDPARENT)
        gid         = GetWindowLong(hWnd, %GWL_ID)
        ghInst      = GetWindowLong(hWnd, %GWL_HINSTANCE)
        gtLineCount = -1
        gTabSize    = 8
        gutter      = 0 '<not impliemented yet> in terms of char spacing
        '-turn off HighLightText Selection flag
        selOnOff = 0
     CASE %WM_DESTROY
        IF ghbit  THEN DeleteObject( ghbit )
        IF gmemDC THEN DeleteDC( gmemDC )
        DestroyCaret()
     CASE %WM_VSCROLL
        IF gtLineCount < 0 THEN EXIT SELECT
        SELECT CASE LOWRD( wParam )
           CASE %SB_THUMBTRACK
              IF gtLineCount < 65536 THEN
                 iVscrollInc = HIWRD(wParam) - gwFirstVisibleLine
              END IF
           CASE %SB_TOP
                iVscrollInc = -gwFirstVisibleLine
           CASE %SB_BOTTOM
                 iVscrollInc =  gtLineCount - gwMaxHeight
           CASE %SB_LINEUP
                iVscrollInc = -1
           CASE %SB_LINEDOWN
                IF gwFirstVisibleLine < gtLineCount - gwMaxHeight + 1 THEN
                   iVscrollInc =  1
                END IF
           CASE %SB_PAGEUP
                iVscrollInc = MIN&(-1, -gwMaxHeight)
           CASE %SB_PAGEDOWN
                iVscrollInc = MAX&(1,   gwMaxHeight)
           CASE ELSE
                iVscrollInc = 0
        END SELECT
        iVscrollInc = MAX&(-gwFirstVisibleLine, MIN&(iVscrollInc, gtLineCount - gwMaxHeight + 1))
        IF iVscrollInc <> 0 AND gwFirstVisibleLine <= gtLineCount - gwMaxHeight + 1 THEN
           gwFirstVisibleLine = MIN&(gwFirstVisibleLine + iVscrollInc, gtLineCount - gwMaxHeight + 1)
          SetVScrollData( hWnd, gwMaxHeight, gtLineCount, gwFirstVisibleLine )
          InvalidateRect( hWnd, BYVAL %NULL , 0 )
          PositionCaret()
        END IF
     CASE %WM_HSCROLL
        IF gtColCount < 0 THEN EXIT SELECT
        SELECT CASE LOWRD( wParam )
           CASE %SB_THUMBTRACK
              IF gtColCount < 65536 THEN
                 iHscrollInc = HIWRD(wParam) - gwFirstVisibleCol
              END IF
           CASE %SB_THUMBPOSITION
           CASE %SB_TOP
                iHscrollInc = -gwFirstVisibleCol
           CASE %SB_BOTTOM
                 iHscrollInc =  gtColCount - gwMaxWidth
           CASE %SB_LINELEFT
                iHscrollInc = -1
           CASE %SB_LINERIGHT
                IF gwFirstVisibleCol < gtColCount - gwMaxWidth + 1 THEN
                   iHscrollInc =  1
                END IF
           CASE %SB_PAGEUP
                iHscrollInc = MIN&(-1, -gwMaxWidth)
           CASE %SB_PAGEDOWN
                iHscrollInc = MAX&(1,   gwMaxWidth)
           CASE ELSE
                iHscrollInc = 0
        END SELECT
        iHscrollInc = MAX&(-gwFirstVisibleCol, MIN&(iHscrollInc, gtColCount - gwMaxWidth + 1))
        IF iHscrollInc <> 0 AND gwFirstVisibleCol <= gtColCount - gwMaxWidth + 1 THEN
           gwFirstVisibleCol = MIN&(gwFirstVisibleCol + iHscrollInc, gtColCount - gwMaxWidth + 1)
           SetHScrollData( hWnd, gwMaxWidth, gtColCount, gwFirstVisibleCol )
           InvalidateRect( hWnd, BYVAL %NULL , 0 )
           PositionCaret()
        END IF
     CASE %WM_SETFONT
        IF wParam <> ghFont THEN
           ghFont = wParam
           SelectObject( gmemDC, ghFont )
           '-Get font parameters
           GetTextMetrics( gmemDC, tm )
           '-Line spacing
           gcyChar = tm.tmHeight + tm.tmExternalLeading
           '-Adjust height to avoid partial lines
           GetWindowRect( hWnd, wRect )
           gwMaxHeight = ( wRect.nBottom - wRect.nTop ) \ gcyChar
           SetWindowPos(hWnd,0,0,0,wRect.nRight-wRect.nLeft,gwMaxHeight*gcyChar+4,%SWP_NOMOVE OR %SWP_NOZORDER)
        END IF
     CASE %WM_SIZE
        'IF HIWRD(lParam) THEN gwMaxHeight = HIWRD(lParam) \ gcyChar '<-cause crash PBWIN v905
        'IF HIWRD(lParam) THEN gwMaxWidth  = LOWRD(lParam) \ gcxChar '<-cause crash PBWIN v905
        IF HIWRD(lParam) THEN gwMaxHeight = HIWRD(lParam) / gcyChar
        IF HIWRD(lParam) THEN gwMaxWidth  = LOWRD(lParam) / gcxChar
        '-create a virtual window that fits current window size
        hDC = GetDC( hWnd )
           IF gmemDC THEN DeleteDC( gmemDC )
           IF ghbit  THEN DeleteObject( ghbit )
           gmemDC = CreateCompatibleDC( hDC )
           GetClientRect( hWnd, wRect )
           IF gmemDC THEN
              hbrush   = GetStockObject( %WHITE_BRUSH )
              IF ISFALSE(ghFont) THEN ghFont = GetStockObject(%ANSI_VAR_FONT)
              ghbit  = CreateCompatibleBitmap( hdc, wRect.nRight, wRect.nBottom )
              IF ghFont THEN SelectObject( gmemDC, ghFont )
              IF hbrush THEN SelectObject( gmemDC, hbrush )
              IF ghbit  THEN SelectObject( gmemDC, ghbit )
              PatBlt( gmemDC, 0, 0, wRect.nRight, wRect.nBottom, %PATCOPY )
              '-Get font parameters
              GetTextMetrics( gmemDC, tm )
              '-Line spacing
              gcyChar = tm.tmHeight + tm.tmExternalLeading
              '-col spacing
              gcxChar = tm.tmAveCharWidth
           END IF
        ReleaseDC( hWnd, hDC )
        gwMaxHeight = wRect.nBottom \ gcyChar
        gwMaxWidth  = wRect.nRight \ gcxChar
        SetVScrollData( hWnd, gwMaxHeight, gtLineCount, gwFirstVisibleLine )
        SetHScrollData( hWnd, gwMaxWidth, gtColCount, gwFirstVisibleCol )
        InvalidateRect( hWnd, BYVAL %NULL, 0 )
        UpdateWindow( hwnd )
     CASE %WM_KEYDOWN
        IF gtLineCount < 0 AND wParam <> %VK_TAB THEN EXIT SELECT
        'xCaret = gcurCol  - gwFirstVisibleCol
        'yCaret = gcurLine - gwFirstVisibleLine
        'Call SetCaretPos( xCaret*gcxChar, yCaret*gcyChar )
        '-If needed, first bring caret into viewable client area
        IF gcurLine < gwFirstVisibleLine OR  gcurLine > gwLastLine THEN
          gwFirstVisibleLine = MIN&(gcurLine, gtLineCount - gwMaxHeight +1)
          SetVScrollData( hWnd, gwMaxHeight,gtLineCount, gwFirstVisibleLine)
          InvalidateRect( hWnd, BYVAL %NULL, 0 )
          xCaret = gcurCol  - gwFirstVisibleCol
          yCaret = gcurLine - gwFirstVisibleLine
          SetCaretPos( xCaret*gcxChar, yCaret*gcyChar )
        END IF
        SELECT CASE (wParam)
           CASE %VK_UP
              IF yCaret < 1 THEN
                SendMessage( hWnd, %WM_VSCROLL, %SB_LINEUP, 0 )
              ELSE
                yCaret = yCaret -1
              END IF
           CASE %VK_DOWN
              IF yCaret > gwMaxHeight -2 THEN
                 SendMessage( hWnd, %WM_VSCROLL, %SB_LINEDOWN, 0 )
                 yCaret = gwMaxHeight -1
              ELSE
                 yCaret = yCaret + 1
              END IF
           CASE %VK_LEFT
              IF xCaret < 1 THEN
                SendMessage( hWnd, %WM_HSCROLL, %SB_LINELEFT, 0 )
              ELSE
                xCaret = xCaret -1
              END IF
           CASE %VK_RIGHT
              IF xCaret > gwMaxWidth -1 THEN
                 SendMessage( hWnd, %WM_HSCROLL, %SB_LINERIGHT, 0 )
              ELSE
                 xCaret = xCaret + 1
              END IF
           CASE %VK_PRIOR 'PgUp
              yCaret = 0
              SendMessage( hWnd, %WM_VSCROLL, %SB_PAGEUP, 0 )
           CASE %VK_NEXT  'PgDn
              yCaret = gwMaxHeight - 1
              SendMessage( hWnd, %WM_VSCROLL, %SB_PAGEDOWN, 0 )
           CASE %VK_HOME
              gwFirstVisibleCol = 0
              SetScrollPos( hWnd, %SB_HORZ,gwFirstVisibleCol, %TRUE )
              InvalidateRect( hWnd, BYVAL %NULL, 0 )
              UpdateWindow( hwnd )
              xCaret = 0
           CASE %VK_END
              nChar& = LEN(sBuffer(gwFirstVisibleLine+yCaret))
              cPos& = nChar& - gwFirstVisibleCol
              IF cPos& > gwMaxWidth THEN
                gwFirstVisibleCol = nChar& - gwMaxWidth+ 1
                SetScrollPos( hWnd, %SB_HORZ, gwFirstVisibleCol, %TRUE )
                InvalidateRect( hWnd, BYVAL %NULL, 0 )
                UpdateWindow( hwnd )
                xCaret = nChar& - gwFirstVisibleCol
              ELSE
                xCaret = cPos&
              END IF
           CASE %VK_DELETE
           CASE %VK_TAB
        END SELECT
        '<todo:> VK_DELETE needs to delete current selection
        IF selOnOff = 1 THEN
            selOnOff =0
            InvalidateRect( hWnd,BYVAL %NULL,0 )
        END IF
        '-update the position of caret
        gcurLine = (yCaret+gwFirstVisibleLine)
        gcurCol  = (xCaret+gwFirstvisibleCol)
        SetCaretPos( xCaret*gcxChar, yCaret*gcyChar )
        ShowCaretPosition( hWnd, xCaret, yCaret )
    CASE %WM_CHAR
      FOR i = 0 TO LOWRD(lParam)-1
        SELECT CASE ( wParam )
          CASE %BS  '-backspace
            '<todo: delete selection first>
            IF selOnOff = 1 THEN selOnOff =0 :CALL InvalidateRect( hWnd,BYVAL %NULL,0 )
            IF xCaret > 0 THEN
              DECR xCaret
              SendMessage( hWnd, %WM_KEYDOWN, %VK_DELETE, 1 )
            END IF
          CASE %TAB '-tab
            IF selOnOff = 1 THEN selOnOff =0 :CALL InvalidateRect( hWnd,BYVAL %NULL,0 )
            IF xCaret < gtColCount-gwFirstVisibleCol-gTabSize THEN
                DO
                    SendMessage( hWnd, %WM_CHAR, %SP, 1)
                LOOP UNTIL (( xCaret MOD gTabSize ) = 0 )
            ELSE
               xCaret = 0
            END IF
          CASE %LF '-line feed
            INCR yCaret
          CASE %CR '-carriage return
            IF SelOnOff=1 THEN SelOnOff = 0
            xCaret = 0
            SendMessage( hWnd, %WM_KEYDOWN,%VK_HOME,0 )
            IF yCaret > gwLastLine-1  THEN
                SendMessage( hWnd, %WM_VSCROLL, %SB_LINEDOWN, 0 )
            ELSE
                yCaret = yCaret + 1
            END IF
          CASE %ESC     '-escape
            IF SelOnOff =1 THEN
               SelOnOFF =0
               InvalidateRect( hWnd, BYVAL %NULL, 0 )
            END IF
          CASE ELSE
            IF selOnOff = 1 THEN
               selOnOff =0
               InvalidateRect( hWnd,BYVAL %NULL,0 )
               '<todo:>delete the selection from sBuffer array here
            END IF
            '*Handle all the other characters here...
            ' Paint directly to screen and handle string operations for
            ' character insertion/deletion.
            'etc...
            INCR xCaret
            IF xCaret = gtColCount THEN
              xCaret = 0
              INCR yCaret
              IF yCaret = gtLineCount THEN yCaret = 0
            END IF
        END SELECT
      NEXT
       '-update the position of caret
       gcurLine = (yCaret+gwFirstVisibleLine)
       gcurCol  = (xCaret+gwFirstvisibleCol)
       SetCaretPos( xCaret*gcxChar, yCaret*gcyChar )
       ShowCaretPosition( hWnd, xCaret, yCaret )
     CASE %WM_TIMER
              IF wParam = 100 THEN
                 '-check if cursor is outside of our client rect
                 GetCursorPos( pt )
                 GetWindowRect( hWnd, rc )
                 '-auto scroll down...
                 IF pt.y > rc.nBottom - GetSystemMetrics(%SM_CYHSCROLL) THEN
                    SendMessage( hWnd, %WM_VSCROLL, %SB_LINEDOWN, 0 )
                    SelEndY = SelEndY + 1
                 ELSEIF pt.y < rc.nTop THEN
                    SendMessage( hWnd, %WM_VSCROLL, %SB_LINEUP, 0 )
                    SelEndY = SelEndY -1
                 ELSEIF pt.x > rc.nRight - GetSystemMetrics(%SM_CXVSCROLL) THEN
                    SendMessage( hWnd, %WM_HSCROLL, %SB_LINERIGHT, 0 )
                    SelEndX = SelEndX +1
                 ELSEIF pt.x < rc.nLeft THEN
                     IF SelEndX < 0 THEN
                        EXIT IF
                     ELSE
                        SendMessage( hWnd, %WM_HSCROLL, %SB_LINELEFT, 0 )
                        SelEndX = SelEndX -1
                     END IF
                 END IF
                  '-update the position of caret
                  gcurLine = (yCaret+gwFirstVisibleLine)
                  gcurCol  = (xCaret+gwFirstvisibleCol)
                  ShowCaretPosition( hWnd, xCaret, yCaret )
              END IF
     CASE %WM_MOUSEMOVE
         IF gtLineCount < 0 THEN EXIT SELECT
         xPos = LOWRD( lParam )
         yPos = HIWRD( lParam )
         '-HighlightedText Selection...
         IF bLButtonIsDown = 1 THEN
            bSelected = 1
            selOnOff  = 1
            IF GetCapture() = %NULL THEN
               SetCapture( hWnd )
               HideCaret( hWnd )
            END IF
            IF ( xPos MOD gcxChar ) >= (gcxChar\2) THEN
                xCaret = (xPos + gcxChar) \ gcxChar
                yCaret = yPos \ gcyChar
            ELSE
                xCaret = xPos \ gcxChar
                yCaret = yPos \ gcyChar
            END IF
            '-update the selEnd on same line
            SelEndY = gwFirstVisibleLine + yCaret
            IF SelEndX < 0 THEN
               xCaret = 0
               SelEndX = gwFirstVisibleCol
               'FUNCTION=0:EXIT FUNCTION
            ELSE
               SelEndX = gwFirstVisibleCol  + xCaret
            END IF
            '-save our caret position for later use
            gcurLine =  SelEndY
            gcurCol  =  SelEndX
            '-output some debug info
            ShowCaretPosition( hWnd, xCaret, yCaret) 'COL,ROW
            InvalidateRect( hWnd, BYVAL %NULL, 0 )
            '-UpdateWindow( hWnd )
            IF bTimerOnOff = 0 THEN
                SetTimer( hWnd, 100, 1, BYVAL %Null )
                bTimerOnOff = 1
            END IF
         END IF
     CASE %WM_LBUTTONDOWN
         xPos = LOWRD( lParam ) 'horizontal position of cursor
         yPos = HIWRD( lParam ) 'vertical position of cursor
         '-Do we have the focus already? <need to do for WM_RBUTTONDOWN too>
         IF (hWnd = GetFocus()) THEN
              '-Yes, we do...
         ELSE
              '-No, we don't, then lets set it to the Edit control
              SetFocus( hWnd )
         END IF
         '-turn off any HighLightText selection
         IF selOnOff = 1 THEN
            selOnOff = 0
            InvalidateRect( hWnd, BYVAL %NULL, 0 )
            'UpdateWindow( hWnd )
         END IF
         '-Here we want to split the hit zone so that the
         ' caret can go left or right from 50% of character width
         IF ( xPos MOD gcxChar ) >= (gcxChar\2) THEN
            xCaret = (xPos + gcxChar) \ gcxChar
            yCaret = yPos \ gcyChar
         ELSE
            xCaret = xPos \ gcxChar
            yCaret = yPos \ gcyChar
         END IF
         '-set our caret to new position
         SetCaretPos( xCaret*gcxChar, yCaret*gcyChar )
         '-initialize selStart position
         SelStartY = gwFirstVisibleLine + yCaret
         SelStartX = gwFirstVisibleCol  + xCaret
         SelEndY   = SelStartY
         SelEndX   = SelStartX
         '-save our caret position
         gcurLine =  SelStartY
         gcurCol  =  SelStartX
         '-output some debug info...
         ShowCaretPosition( hWnd, xCaret, yCaret ) 'COL,ROW
         '-Let the others know the Left mouse button is down!
         bLButtonIsDown = 1
     CASE %WM_LBUTTONUP
        '-are we ending a Text Selection?
         IF bLButtonIsDown = 1 THEN
            bLButtonIsDown = 0
            IF bSelected = 1 THEN
                bSelected = 0
                IF bTimerOnOff =1 THEN
                    CALL KillTimer( hWnd, 100 )
                    bTimerOnOff =0
                END IF
                ReleaseCapture()
                '-update the position of caret
                gcurLine = (yCaret+gwFirstVisibleLine)
                gcurCol  = (xCaret+gwFirstvisibleCol)
                '-set the caret to it's new position
                SetCaretPos( xCaret*gcxChar, yCaret*gcyChar )
                ShowCaret( hWnd )
            END IF
         END IF
         '-output some debug info...
         ShowCaretPosition( hWnd, xCaret, yCaret )
    CASE %WM_CAPTURECHANGED
        IF lParam <> hWnd THEN
           SendMessage( hWnd,%WM_LBUTTONUP, 0, 0 )
        END IF
    CASE %WM_RBUTTONDOWN
        '<todo:> load up context menu
    CASE %WM_LBUTTONDBLCLK
        '<todo:> if on Char, highlight full word
    CASE %WM_SETFOCUS
        '-Create and show the caret
        CreateCaret( hWnd, BYVAL %NULL, 2, gcyChar )
        '-SetCaretPos( (gwFirstVisibleCol+xCaret)*gcxChar, (gwFirstVisibleLine+yCaret)*gcyChar )
        ShowCaret( hWnd )
    CASE %WM_KILLFOCUS
        '-Hide and destroy the caret
        HideCaret( hWnd )
        DestroyCaret()
     CASE %WM_PAINT
        'GetCaretPos( pt )
        HideCaret( hWnd )
        hDC = BeginPaint(hWnd, ps)
        '-don't bother if no text in our control
        IF gtLineCount > -1 THEN
           GetClientRect(hWnd, wRect)
           wRect.nRight  = wRect.nRight  -wRect.nLeft
           wRect.nBottom = wRect.nBottom -wRect.nTop
           '-get window extents...
           gwFirstVisibleLine = MAX&(0, MIN&(gwFirstVisibleLine, gtLineCount - gwMaxHeight + 1))
           gwLastLine  = MIN&(gtLineCount, gwFirstVisibleLine + gwMaxHeight - 1)
           '-Clean up our drawing surface
           PatBlt( gmemDC, 0, 0, wRect.nRight, wRect.nBottom, %PATCOPY )
           '-determine Horizontal position...
           x& = gcxChar*( gutter - gwFirstVisibleCol )
           '---first dump all visible text from our dynamic array...
           FOR i = gwFirstVisibleLine TO gwLastLine
                y = gcyChar * (-gwFirstVisibleLine + i)
                TextOut( gmemDC, x&, y, BYVAL STRPTR(@gpBuf[i]), LEN(@gpBuf[i]) )
           NEXT
           '---next highlight all selected text...
           IF  selOnOff = 1  THEN
            '-set our color for the highlighted text
            SetTextColor( gmemDC, GetSysColor(%COLOR_HIGHLIGHTTEXT) )
            SetBkColor( gmemDC, GetSysColor(%COLOR_HIGHLIGHT) )
            '-set our selection limits WRT our string buffer array
            IF SelStartY < 0 THEN SelStartY =0
            IF SelEndY   < 0 THEN SelEndY =0
            IF SelStartY > gtLineCount THEN SelStartY = gtLineCount
            IF SelEndY   > gtLineCount THEN SelEndY = gtLineCount
            IF SelEndX   < 0 THEN SelEndX = 0
            '-selection is positive(going downwards)...
            IF SelStartY =< SelEndY THEN
                FOR i = SelStartY TO SelEndY
                    y = gcyChar * (-gwFirstVisibleLine + i)
                    IF i = SelStartY THEN '-do first line
                        IF SelStartY = SelEndY THEN '-do Mid section Start-End of a line
                             IF SelStartX < SelEndX THEN  '-going right
                                stemp$ = MID$(sBuffer(i),SelStartX+1,SelEndX-SelStartX)
                                TextOut( gmemDC, x&+(SelStartX*gcxChar), y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                             ELSE 'going left
                                stemp$ = MID$(sBuffer(i),SelEndX+1,SelStartX-SelEndX)
                                TextOut( gmemDC, x&+(SelEndX*gcxChar), y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                             END IF
                        ELSE  '-do partial, SelStartX-to end of a full line
                             stemp$ = MID$(sBuffer(i),SelStartX+1,LEN(sBuffer(i))-SelStartX)
                             TextOut( gmemDC, x&+(SelStartX*gcxChar), y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                        END IF
                    ELSEIF i = SelEndY THEN '-do last line, 0 to SelEndX of a full line
                        stemp$ = MID$(sBuffer(i), 1, SelEndX)
                        TextOut( gmemDC, x&, y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                    ELSE  '-do whole line
                        TextOut( gmemDC, x&, y, BYVAL STRPTR(@gpBuf[i]), LEN(@gpBuf[i]) )
                    END IF
                NEXT
            ELSE
                '-selection is negative(going upwards)...
                FOR i = SelEndY TO SelStartY
                    y = gcyChar * (-gwFirstVisibleLine + i)
                    IF i = SelEndY THEN '-do first line
                        IF SelEndY = SelStartY THEN '-do Mid section Start-End of a line
                             IF SelEndX > SelStartX THEN 'going right
                                stemp$ = MID$(sBuffer(i),SelStartX-1,SelEndX-SelStartX)
                                TextOut( gmemDC, x&+(SelStartX*gcxChar), y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                             ELSE '-going left
                                 stemp$ = MID$(sBuffer(i),SelEndX-1,SelStartX-SelEndX)
                                TextOut( gmemDC, x&+(SelEndX*gcxChar), y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                             END IF
                        ELSE  '-do partial, SelStartX-to end of a full line
                             stemp$ = MID$(sBuffer(i),SelEndX+1,LEN(sBuffer(i))-SelEndX)
                             TextOut( gmemDC, x&+(SelEndX*gcxChar), y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                        END IF
                    ELSEIF i = SelStartY THEN '-do last line, 0 to SelStartX of a full line
                        stemp$ = MID$(sBuffer(i), 1, SelStartX)
                        TextOut( gmemDC, x&, y, BYVAL STRPTR(stemp$), LEN(stemp$) )
                    ELSE  '-do whole line
                        TextOut( gmemDC, x&, y, BYVAL STRPTR(@gpBuf[i]), LEN(@gpBuf[i]) )
                    END IF
                NEXT
            END IF
            '-Restore Color, Black text, white background
            SetTextColor( gmemDC, RGB(0,0,0))
            SetBkColor( gmemDC, RGB(255,255,255) )
           END IF
           '-Screen blaster...
           BitBlt( hDC, wRect.nLeft, wRect.nTop , wRect.nRight, wRect.nBottom, gmemDC, 0, 0, %SRCCOPY )
        END IF
        EndPaint( hWnd, ps )
        'SetCaretPos( pt.x-gcxChar , pt.y-gcyChar )
        'SetCaretPos( (xCaret-gwFirstVisibleCol)*gcxChar, (yCaret-gwFirstVisibleLine)*gcyChar )
        ShowCaret( hWnd )
     CASE %WM_ERASEBKGND
        FUNCTION = 1 :EXIT FUNCTION
   END SELECT
        FUNCTION = DefWindowProc( hWnd, uMsg, wParam, lParam )
END FUNCTION

'---------------------------------------------------------------------------
' WinMain:
'---------------------------------------------------------------------------
FUNCTION WINMAIN (BYVAL hInstance AS LONG,BYVAL hPrevInstance AS LONG, BYVAL lpCmdLine AS ASCIIZ PTR, BYVAL iCmdShow AS LONG) AS LONG

    LOCAL uMsg      AS tagMsg
    LOCAL wc        AS WndClassEx
    LOCAL hWnd      AS DWORD
    LOCAL rct       AS RECT
    LOCAL szpgmname AS ASCIIZ * 20

    szpgmname        = "SIMPLEEDIT"
    wc.cbSize        = SIZEOF(wc)
    wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS
    wc.lpfnWndProc   = CODEPTR( MainWndProc )
    wc.cbClsExtra    = 0
    wc.cbWndExtra    = 0
    wc.hInstance     = hInstance
    wc.hIcon         = LoadIcon( hInstance, "MAINICON" )
    wc.hCursor       = LoadCursor( %NULL, BYVAL %IDC_ARROW )
    wc.hbrBackground = GetStockObject( %LTGRAY_BRUSH )
    wc.lpszMenuName  = %NULL
    wc.lpszClassName = VARPTR(szpgmname)
    wc.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)
    RegisterClassEx( wc )

    szpgmname        = "SEDIT"
    wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS
    wc.lpfnWndProc   = CODEPTR( SimpleEditProc )
    wc.cbClsExtra    = 0
    wc.cbWndExtra    = 0
    wc.hInstance     = GetModuleHandle( BYVAL %NULL )
    wc.hIcon         = %NULL
    wc.hCursor       = LoadCursor( %NULL, BYVAL %IDC_IBEAM )
    wc.hbrBackground = %COLOR_WINDOW + 1
    wc.lpszMenuName  = %NULL
    wc.lpszClassName = VARPTR( szpgmname )
    RegisterClassEx(wc)

    ghInst = hInstance
    style& = %WS_OVERLAPPEDWINDOW
    '-create the main window...
    hWnd = CreateWindowEx(0,"SIMPLEEDIT","Simple Edit Control:",style&,210,110,650,350,%HWND_DESKTOP,%NULL,hInstance,BYVAL %NULL)
    ShowWindow( hWnd, %SW_SHOW )
    UpdateWindow( hWnd )
    WHILE GetMessage(uMsg, %NULL, 0, 0)
        TranslateMessage uMsg
        DispatchMessage uMsg
    WEND
    FUNCTION = uMsg.wParam
END FUNCTION

'--------------------------------------------------------------------------------
' MainWndProc:
'--------------------------------------------------------------------------------
FUNCTION MainWndProc(BYVAL hWnd AS LONG,BYVAL wMsg AS LONG,BYVAL wParam AS LONG,BYVAL lParam AS LONG)AS LONG

    LOCAL  I            AS LONG
    LOCAL  tl           AS LONG
    LOCAL  Lb           AS LOGBRUSH
    STATIC hBrushList   AS LONG
    LOCAL  Bkgnd        AS LONG
    LOCAL  Frgnd        AS LONG
    STATIC hFont        AS LONG
    LOCAL  iVscrollInc  AS LONG
    LOCAL  iHscrollInc  AS LONG
    LOCAL  si           AS SCROLLINFO
    LOCAL  rc           AS RECT

  SELECT CASE ( wMsg )
    CASE %WM_CREATE
            ghMain = hWnd
            Bkgnd = RGB( &H00, &H00, &HFF )
            Frgnd = RGB( &HFF, &HFF, &HFF )
            GetClientRect( hWnd,rc )
            '-add some debug windows at the top to display caret position info
            id&=100 :x&=80 :y&=0 :cx&=160 :cy&=24
            ghCaretw = CreateWindowEx(%WS_EX_CLIENTEDGE,"STATIC",BYVAL 0,%WS_VISIBLE OR %WS_CHILD,x&,y&,cx&,cy&,hWnd,id&,GetWindowLong(hWnd, %GWL_HINSTANCE),BYVAL 0)
            '...this is our selection boundary info window
            id&=101 :x&=240 :y&=0 :cx&=rc.nRight-240 :cy&=24
            ghSelectw = CreateWindowEx(%WS_EX_CLIENTEDGE,"STATIC",BYVAL 0,%WS_VISIBLE OR %WS_CHILD,x&,y&,cx&,cy&,hWnd,id&,GetWindowLong(hWnd, %GWL_HINSTANCE),BYVAL 0)

            '-add a few command buttons...
            id&=102 :x&=0 :y&=0 :cx&=40 :cy&=24
            ghOpen = CreateWindowEx(0,"BUTTON","O",%WS_VISIBLE OR %WS_CHILD,x&,y&,cx&,cy&,hWnd,id&,GetWindowLong(hWnd, %GWL_HINSTANCE),BYVAL 0)
            id&=103 :x&=40 :y&=0 :cx&=40 :cy&=24
            ghSave = CreateWindowEx(0,"BUTTON","S",%WS_VISIBLE OR %WS_CHILD,x&,y&,cx&,cy&,hWnd,id&,GetWindowLong(hWnd, %GWL_HINSTANCE),BYVAL 0)

            '-create a single instance edit control...
            id&=104 :x&=0 :y&=24 :cx&=rc.nRight :cy&=rc.nBottom-24
            ghEdit = CreateWindowEx(%WS_EX_CLIENTEDGE,"SEDIT",BYVAL 0,%WS_VISIBLE OR %WS_CHILD OR %WS_VSCROLL OR %WS_HSCROLL,x&,y&,cx&,cy&,hWnd,id&,GetWindowLong(hWnd, %GWL_HINSTANCE),BYVAL 0)

            '-Added 7/6/2011, force activation of scrollbar, otherwise messes up initial caret highlighting(review later)
            SetWindowPos hWnd, %NULL, 0, 0, 1000, 600, %SWP_NOMOVE OR %SWP_NOZORDER
            '-Note: we want to use a fixed width font.
            hDC& = GetDC( hWnd )
            hFont = CreateFont(-1 * (12 * GetDeviceCaps(hDC&, %LOGPIXELSY)) /72, 0, 0, 0, 0, 0, 0, 0, %DEFAULT_CHARSET, 0, 0, %PROOF_QUALITY, 0, "Courier New")
            ReleaseDC( hWnd, hDC& )
            SendMessage( ghEdit, %WM_SETFONT, hFont, 0 )
            '-Create brush for background color.
            Lb.lbStyle = %BS_SOLID
            Lb.lbColor = Bkgnd
            hBrushList = CreateBrushIndirect(Lb)
            '-Create an array for testing purposes. Later we can add the
            ' Open/Save handler after we get things running first!
            REDIM sBuffer(0:13000) AS STRING
            FOR I = 0 TO UBOUND(sBuffer)
                sBuffer(I) = "Line no. " + FORMAT$(I,"####") + " : mov.w #55,R1 : stc #FFFF : jsr @R5 : bne @2000 :   Line number...  " + STR$(I)
            NEXT
            '-Initialize array info...
            gpBuf       = VARPTR(sBuffer(0))
            gtLineCount = UBOUND(sBuffer)
            gwFirstVisibleLine = 0
            '-determine column width, used "POMA" number
            gtColCount  = 255 'in terms of characters.
            gwFirstVisibleCol  = 0
            SetFocus( ghEdit )
     CASE %WM_SETFOCUS
        SetFocus( ghEdit )
        '-SendMessage( ghEdit, %WM_SETFOCUS, wParam, 0 )
     'CASE %WM_KILLFOCUS
     '   SendMessage( ghEdit, %WM_KILLFOCUS, wParam, 0 )
     '   FUNCTION =0:EXIT FUNCTION
     CASE %WM_ERASEBKGND : FUNCTION =1 : EXIT FUNCTION
     CASE %WM_SIZE
        GetClientRect( hWnd,rc )
        x&=0 :y&=24 :cx&=rc.nRight :cy&=rc.nBottom-24
        MoveWindow( ghEdit, x&, y&, cx&, cy& , %TRUE )
        x&=240 :y&=0 :cx&=rc.nRight-240 :cy&=24
        MoveWindow( ghSelectw, x& , y&, cx&, cy&, %TRUE)
     CASE %WM_COMMAND
     SELECT CASE LOWRD(wParam)
            CASE 102
                IF HIWRD(wParam) = %BN_CLICKED THEN 'Open File
                   'InsertLineToArray()                       '<-**testing**
                   AddLineToEndofArray()
                END IF
            CASE 103
                IF HIWRD(wParam) = %BN_CLICKED THEN 'Save File
                   'DeleteLineFromArray()
                   UpdateLineInArray()
                END IF
        END SELECT
     CASE %WM_DESTROY
        IF hBrushList THEN DeleteObject( hBrushList )
        IF hFont      THEN DeleteObject( hFont )
        PostQuitMessage( 0 )
    END SELECT
    FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)
END FUNCTION
